<?

require_once("secrets.php");
require_once("cleanup.php");

$max_torrent_size = 1000000;
$announce_interval = 1800;
$signup_timeout = 86400 * 3;
$max_dead_torrent_time = 6 * 3600;

$torrent_dir = "/usr/local/www/torrents";       # must be writable for httpd user
$stats_dir = "/usr/local/www/data/stats";       # path to directory where stat graphs are generated
$stats_url = "http://static.voracity.net/stats/";
$default_stat_fn = "na.png";                    # graph to show if no graphs have actually been create yet

# the first one will be displayed on the pages
$announce_urls = array();
$announce_urls[] = "http://voracity.net/announce.php";

$autoclean_interval = 600;

/*  master column list:
    
    Col.Name                users.colpref name:     CLASS assigned to elements in that column:
    ------------------------------------------------------------------------------------------
    Category                colpref_cat             catcol
    Name                    colpref_name            namecol
    Visible                                         viscol
    # Comments              colpref_comm            commentscol
    Add Date                colpref_added           addedcol
    # Files                 colpref_nfiles          nfilescol
    Size                    colpref_size            sizecol
    Views                   colpref_views           viewscol
    Hits                    colpref_hits            hitscol
    Completed (snatched)    colpref_completes       compcol
    Seeders                 colpref_seeders         seederscol
    Leechers                colpref_leechers        leechercol
    Owner                   colpref_owner           ownercol
*/

$colprefs = array(
    'colpref_cat',
    'colpref_name',
    '',
    'colpref_comm',
    'colpref_added',
    'colpref_nfiles',
    'colpref_size',
    'colpref_views',
    'colpref_hits',
    'colpref_completes',
    'colpref_seeders',
    'colpref_leechers',
    'colpref_owner',
);

$table_hdrs = array(
    'Type',
    'Name',
    'Visible',
    'Comments',
    'Age',
    'Files',
    'Size',
    'Views',
    'Hits',
    'Completed',
    'Seeders',
    'Leechers',
    'Owner',
);

$col_longnames = array(
    'Category',
    'Torrent name',
    'Visible?',
    'Number of comments',
    'Date torrent was uploaded',
    'Number of files in the torrent',
    'Size of the torrent',
    'Number of views of the details',
    'Number of hits',
    'Number of complete downloads',
    'Number of seeders',
    'Number of leechers',
    'Owner (person who uploaded the torrent)',
);


$col_ids = array(
    'catcol',
    'namecol',
    'viscol',
    'commentscol',
    'addedcol',
    'nfilescol',
    'sizecol',
    'viewscol',
    'hitscol',
    'compcol',
    'seederscol',
    'leechercol',
    'ownercol',
);

$default_prefs = array(
    'colpref_cat' => 'yes',
    'colpref_name' => 'yes',
    'colpref_comm' => 'yes',
    'colpref_added' => 'yes',
    'colpref_nfiles' => 'no',
    'colpref_size' => 'yes',
    'colpref_views' => 'no',
    'colpref_hits' => 'yes',
    'colpref_completes' => 'yes',
    'colpref_seeders' => 'yes',
    'colpref_leechers' => 'yes',
    'colpref_owner' => 'yes',
);

# the field names to ORDER BY for sorting
$col_sortfields = array(
    'categories.short_name',
    'torrents.name',
    'torrents.visible',
    'torrents.comments',
    'torrents.added',
    'torrents.numfiles',
    'torrents.size',
    'torrents.views',
    'torrents.hits',
    'torrents.times_completed',
    'torrents.seeders',
    'torrents.leechers',
    'users.username',
);

#maps the default sort order for each column
$col_sortorder = array(
    'ASC',
    'ASC',
    'DESC',
    'DESC',
    'DESC',
    'DESC',
    'DESC',
    'DESC',
    'DESC',
    'DESC',
    'DESC',
    'DESC',
    'ASC',
);


function dbconn($autoclean = 1) {
    global $mysql_host, $mysql_user, $mysql_pass, $mysql_db;

    @mysql_pconnect($mysql_host, $mysql_user, $mysql_pass)
        or die(mysql_error());
    mysql_select_db($mysql_db)
        or die(mysql_error());

    userlogin();

    if ($autoclean)
        register_shutdown_function("autoclean");
}

function userlogin() {
    unset($GLOBALS["CURUSER"]);
    if (empty($_COOKIE["uid"]) || empty($_COOKIE["pass"]))
        return;
    $id = 0 + $_COOKIE["uid"];
    if (!$id || strlen($_COOKIE["pass"]) != 32)
        return;
    $res = mysql_query("SELECT * FROM users WHERE id = $id AND status = 'confirmed'");
    $row = mysql_fetch_array($res);
    if (!$row)
        return;
    $sec = hash_pad($row["secret"]);
    if ($_COOKIE["pass"] !== md5($sec . $row["password"] . $sec))
        return;
    $GLOBALS["CURUSER"] = $row;
    mysql_query("UPDATE users SET last_access = NOW() WHERE id = " . $row["id"]);
}

function autoclean() {
    global $autoclean_interval;

    
    if(isset($_GET["testing"]))
        return;
    
    $now = time();
    $docleanup = 0;

    $res = mysql_query("SELECT value_u FROM avps WHERE arg = 'lastcleantime'");
    $row = mysql_fetch_array($res);
    if (!$row) {
        mysql_query("INSERT INTO avps (arg, value_u) VALUES ('lastcleantime',$now)");
        return;
    }
    $ts = $row[0];
    if ($ts + $autoclean_interval > $now)
        return;
    mysql_query("UPDATE avps SET value_u=$now WHERE arg='lastcleantime' AND value_u = $ts");
    if (!mysql_affected_rows())
        return;

    docleanup();
}

function unesc($x) {
    if (get_magic_quotes_gpc())
        return stripslashes($x);
    return $x;
}

function mksize($s, $nbsp="") {
    $x = 3;
    $a = array("","k","M","G");
    for (;;) {
        $v = pow(1024, $x);
        if (!$x || $s >= $v) {
            $ss = sprintf("%.".$x."f", ($s / $v));
            $xx = $ss . ($nbsp ? "&nbsp;" : " ") . $a[$x] . "B";
            break;
        }
        $x--;
    }
    return $xx;
}

function deadtime() {
    global $announce_interval;
    return time() - floor($announce_interval * 1.3);
}

function mkprettytime($s) {
    if ($s < 0)
        $s = 0;
    $t = array();
    foreach (array("60:sec","60:min","24:hour","0:day") as $x) {
        $y = explode(":", $x);
        if ($y[0] > 1) {
            $v = $s % $y[0];
            $s = floor($s / $y[0]);
        }
        else
            $v = $s;
        $t[$y[1]] = $v;
    }

    if ($t["day"])
        return $t["day"] . " day(s), " . sprintf("%02d:%02d:%02d", $t["hour"], $t["min"], $t["sec"]);
    if ($t["hour"])
        return sprintf("%d:%02d:%02d", $t["hour"], $t["min"], $t["sec"]);
    if ($t["min"])
        return sprintf("%d:%02d", $t["min"], $t["sec"]);
    return $t["sec"] . " secs";
}

function mkprettytime2($s) {
    if ($s < 0)
        $s = 0;
    $t = array();
    foreach (array("60:sec","60:min","24:hour","0:day") as $x) {
        $y = explode(":", $x);
        if ($y[0] > 1) {
            $v = $s % $y[0];
            $s = floor($s / $y[0]);
        }
        else
            $v = $s;
        $t[$y[1]] = $v;
    }

    if ($t["day"])
        return sprintf("%dd&nbsp;%02dh&nbsp;%02dm", $t["day"], $t["hour"], $t["min"]);
    if ($t["hour"])
        return sprintf("%02dh&nbsp;%02dm", $t["hour"], $t["min"]);
    if ($t["min"])
        return sprintf("%02dm&nbsp;%02ds", $t["min"], $t["sec"]);
    return $t["sec"] . " secs";
}


function mkglobal($vars) {
    if (!is_array($vars))
        $vars = explode(":", $vars);
    foreach ($vars as $v) {
        if (isset($_GET[$v]))
            $GLOBALS[$v] = unesc($_GET[$v]);
        elseif (isset($_POST[$v]))
            $GLOBALS[$v] = unesc($_POST[$v]);
        else
            return 0;
    }
    return 1;
}

function tr($x,$y,$noesc=0) {
    if ($noesc)
        $a = $y;
    else {
        $a = htmlspecialchars($y);
        $a = str_replace("\n", "<br />\n", $a);
    }
    print("<tr><td align=\"right\">$x</td><td>$a</td></tr>\n");
}

function validfilename($name) {
    return preg_match('/^[^\0-\x1f:\\\\\/?*\xff#<>|]+$/si', $name);
}

function validemail($email) {
    return preg_match('/^[\w.-]+@([\w.-]+\.)+[a-z]{2,6}$/is', $email);
}

function sqlesc($x) {
    return "'".mysql_real_escape_string($x)."'";
}

function sqlwildcardesc($x) {
    return str_replace(array("%","_"), array("\\%","\\_"), mysql_real_escape_string($x));
}

function urlparse($m) {
    $t = $m[0];
    if (preg_match(',^\w+://,', $t))
        return "<a href=\"$t\">$t</a>";
    return "<a href=\"http://$t\">$t</a>";
}

function parsedescr($d) {
    $pd = str_replace(array("\n", "\r"), array("<br />\n", ""), htmlspecialchars($d));
    $pd = preg_replace_callback('(\w+://([^\s/:@]+(:[^\s/:@]++)?@)?|\bwww\.)[\w.-]+(:\d+)?(/[-\w=./?&%+#;|@]*)?[0-9a-z/]is', "urlparse", $pd);
    return $pd;
}

function stdhead($title = "") {
    global $CURUSER;
    header("Content-Type: text/html; charset=iso-8859-1");
    //header("Pragma: No-cache");
    if ($title == "")
        $title = "voracity.net";
    else
        $title = "voracity.net - " . htmlspecialchars($title);
/*
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">
*/
;

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html><head>
<title><?= $title ?></title>
<link rel="stylesheet" href="http://static.voracity.net/torrent.css" type="text/css" />
</head>
<body>

<div id="topnavcontain"><table class="topnav"><tr>
<td><a href="index.php">Home</a></td>
<td><a href="http://static.voracity.net/minifaq.html">Read This!</a></td>
<td><a href="http://static.voracity.net/news.html">News</a> (<?= date("M-d", filemtime("/usr/local/www/data/news.html")) ?>)</td>
<td><a href="upload.php">Upload</a></td>
<td><a href="freq.php">Feature Requests</a></td>
<? if (!$CURUSER) { ?>
<td><a href="login.php">Login</a> / <a href="signup.php">Signup</a></td>
<? } else { ?>
<td><a href="my.php"><?= htmlspecialchars($CURUSER["username"]) ?>'s settings</a></td>
<? } ?>
</tr>
</table>

<table class="topnav2"><tr>
<td>Forums:</td>
<td><a href="http://www.filesoup.com/phpBB2/viewforum.php?f=15">Requests/Reseeds</a></td>
<td><a href="http://www.filesoup.com/phpBB2/viewforum.php?f=55">Site Help</a></td>
</table>

<? 
if (isset($_GET["testing"])) print "<p>(this is the test DB)</p>"; 
/* else print "<p>(<a href=\"" . mkurl( array_merge($urlparams, array("testing" => "1")) ) . "\">click here for the test DB</a>)</p>"; */
?>

</div>

<?
}



function stdfoot() {
?>
<div id="disclaim"><span class="attention">Attention:</span> None of the content listed on these pages is located on this server.  
We maintain a database of filenames and hash data only.  <a href="mailto:admin@voracity.net">admin@voracity.net</a></div></body></html>
<?
}

function genbark($x,$y) {
    stdhead($y);
    print("<h2>" . htmlspecialchars($y) . "</h2>\n");
    print("<p>" . htmlspecialchars($x) . "</p>\n");
    stdfoot();
    exit();
}

function mksecret($len = 20) {
    $ret = "";
    for ($i = 0; $i < $len; $i++)
        $ret .= chr(mt_rand(0, 255));
    return $ret;
}

function httperr($code = 404) {
    header("HTTP/1.0 404 Not found");
    print("<h1>Not Found</h1>\n");
    print("<p>Sorry pal :(</p>\n");
    exit();
}

function logincookie($id, $password, $secret, $updatedb = 1) {
    $md5 = md5($secret . $password . $secret);

    setcookie("uid", $id, 0x7fffffff, "/");
    setcookie("pass", $md5, 0x7fffffff, "/");

    if ($updatedb)
        mysql_query("UPDATE users SET last_login = NOW() WHERE id = $id");
}

function logoutcookie() {
    setcookie("uid", "", 0x7fffffff, "/");
    setcookie("pass", "", 0x7fffffff, "/");
}

function loggedinorreturn() {
    global $CURUSER;
    if (!$CURUSER) {
        header("Refresh: 0; url=login.php?returnto=" . urlencode($_SERVER["REQUEST_URI"]));
        exit();
    }
}

function deletetorrent($id) {
    global $torrent_dir;
    mysql_query("DELETE FROM torrents WHERE id = $id");
    foreach(explode(".","peers.files.comments") as $x)
        mysql_query("DELETE FROM $x WHERE torrent = $id");
    unlink("$torrent_dir/$id.torrent");
}

function mkurl($urlparams) {
    # passed an associative array, this returns a href to the current script
    # that also includes the parameters in urlparams.
    
    if( count($urlparams) == 0 )
        return $_SERVER["SCRIPT_NAME"];  # the case of no params is easy
                
    $params = "";

    foreach ($urlparams as $p => $val) {
        if( $params != "" )
            $params .= "&amp;$p=" . urlencode($val);
        else
            $params .= "$p=" . urlencode($val);
    }

    return $_SERVER["SCRIPT_NAME"] . "?" . $params;
}


function pager($rpp, $count, $urlparams, $opts = array()) {
    $pages = ceil($count / $rpp);

    if (!$opts["lastpagedefault"])
        $pagedefault = 0;
    else {
        $pagedefault = floor(($count - 1) / $rpp);
        if ($pagedefault < 0)
            $pagedefault = 0;
    }

    if (isset($_GET["page"])) {
        $page = 0 + $_GET["page"];
        if ($page < 0)
            $page = $pagedefault;
    }
    else
        $page = $pagedefault;

    $pager = "";

    $mp = $pages - 1;
    $as = "<b>&lt;&lt;&nbsp;Prev</b>";
    if ($page >= 1) {
        $href = mkurl( array_merge($urlparams, array("page" => $page - 1)) );
        $pager .= "<a href=\"$href\">$as</a>";
    }
    else
        $pager .= $as;
    $pager .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    $as = "<b>Next&nbsp;&gt;&gt;</b>";
    if ($page < $mp && $mp >= 0) {
        $href = mkurl( array_merge($urlparams, array("page" => $page + 1)) );
        $pager .= "<a href=\"$href\">$as</a>";
    }
    else
        $pager .= $as;

    if ($count) {
        $pagerarr = array();
        $dotted = 0;
        $dotspace = 3;
        $dotend = $pages - $dotspace;
        $curdotend = $page - $dotspace;
        $curdotstart = $page + $dotspace;
        for ($i = 0; $i < $pages; $i++) {
            if (($i >= $dotspace && $i <= $curdotend) || ($i >= $curdotstart && $i < $dotend)) {
                if (!$dotted)
                    $pagerarr[] = "...";
                $dotted = 1;
                continue;
            }
            $dotted = 0;
            $start = $i * $rpp + 1;
            $end = $start + $rpp - 1;
            if ($end > $count)
                $end = $count;
            $text = "$start&nbsp;-&nbsp;$end";
            if ($i != $page) {
                $href = mkurl( array_merge($urlparams, array("page" => $i)) );
                $pagerarr[] = "<a href=\"$href\">$text</a>";
            } else {
                $pagerarr[] = "<b>$text</b>";
            }            
        }
        $pagerstr = join(" | ", $pagerarr);
        $pagertop = "<p align=\"center\">$pager<br />$pagerstr</p>\n";
        $pagerbottom = "<p align=\"center\">$pagerstr<br />$pager</p>\n";
    } else {
        $pagertop = "<p align=\"center\">$pager</p>\n";
        $pagerbottom = $pagertop;
    }

    $start = $page * $rpp;

    return array($pagertop, $pagerbottom, "LIMIT $start,$rpp");
}


function pagernew($rpp, $count, $urlparams, $opts = array()) {
    // all page numbers presented to user are 1-based

    $last_page = intval( ceil($count / $rpp) );       // same meaning as "number of pages"
    if($last_page < 1)      // case where count = 0
        $last_page = 1;

    if (!$opts["lastpagedefault"])
        $pagedefault = 1;
    else {
        $pagedefault = $last_page;
    }

    if (isset($urlparams["page"]))
        $page = 0 + $urlparams["page"];     // already been validated
    else
        $page = $pagedefault;

    $pager_head = "<div class=\"pcontainer\"><table class=\"pager\"><tr>\n";
    
    $pager_th = "<th colspan=\"4\">page&nbsp<form action=\"" . $_SERVER["SCRIPT_NAME"] . "\">" .
                "<input class=\"pnum\" type=\"text\" name=\"page\" value=\"$page\" maxlength=\"3\"/>";
    foreach( $urlparams as $p => $val )
        if( strtolower($p) != "page" )
            $pager_th .= "<input type=\"hidden\" name=\"$p\" value=\"$val\" />";
    $pager_th .= "</form>&nbsp;of $last_page</th>";

    # double left angle: laquo
    # single left angle: lsaquo
    # single right angle: rsaquo
    # double right angle: raquo

    # left filled triangle = "&#9668;"
    # right filled triangle = "&#9658;"

    $first = "<span class=\"navarr\">&laquo;</span><br />first";
    $prev = "<span class=\"navarr\">&lsaquo;</span><br />prev";
    $next = "<span class=\"navarr\">&rsaquo;</span><br />next";
    $last = "<span class=\"navarr\">&raquo;</span><br />last";

    $pager = "<tr>";
    
    if($page > 1)   // more that one page, and not on first page?
        $pager .= "<td><a href=\"" . mkurl( array_merge($urlparams, array("page" => 1)) ) . "\">$first</a></td>\n" .
                  "<td><a href=\"" . mkurl( array_merge($urlparams, array("page" => $page - 1)) ) . "\">$prev</a></td>\n";
    else
        $pager .= "<td>$first</td>\n<td>$prev</td>\n";
   
    if($page < $last_page)          # not on last page (implies that there's >1 page)
        $pager .= "<td><a href=\"" . mkurl( array_merge($urlparams, array("page" => $page + 1)) ) . "\">$next</a></td>\n" .
                  "<td><a href=\"" . mkurl( array_merge($urlparams, array("page" => $last_page)) ) . "\">$last</a></td>\n";
    else
        $pager .= "<td>$next</td>\n<td>$last</td>\n";

    $pager .= "</tr></table></div>\n";    

    $start = ($page - 1) * $rpp;            // this is 0-based

    return array( $pager_head . $pager_th . $pager , $pager_head . $pager, "LIMIT $start,$rpp");
}



function downloaderdata($res) {
    $rows = array();
    $ids = array();
    $peerdata = array();
    while ($row = mysql_fetch_assoc($res)) {
        $rows[] = $row;
        $id = $row["id"];
        $ids[] = $id;
        $peerdata[$id] = array(downloaders => 0, seeders => 0, comments => 0);
    }

    if (count($ids)) {
        $allids = implode(",", $ids);
        $res = mysql_query("SELECT COUNT(*) AS c, torrent, seeder FROM peers WHERE torrent IN ($allids) GROUP BY torrent, seeder");
        while ($row = mysql_fetch_assoc($res)) {
            if ($row["seeder"] == "yes")
                $key = "seeders";
            else
                $key = "downloaders";
            $peerdata[$row["torrent"]][$key] = $row["c"];
        }
        $res = mysql_query("SELECT COUNT(*) AS c, torrent FROM comments WHERE torrent IN ($allids) GROUP BY torrent");
        while ($row = mysql_fetch_assoc($res)) {
            $peerdata[$row["torrent"]]["comments"] = $row["c"];
        }
    }

    return array($rows, $peerdata);
}

function commenttable($rows) {
    print("<table border=\"1\" align=\"center\" cellpadding=\"15\">\n");
    $count = 0;
    foreach ($rows as $row) {
        print("<tr>\n");
        if (isset($row["username"]))
            print("<td class=\"heading\"><a name=\"comm" . $row["id"] . "\">" . htmlspecialchars($row["username"]) . "</a></td>\n");
        else
            print("<td><a name=\"comm" . $row["id"] . "\"><i>(orphaned)</i></a></td>\n");
        print("<td align=\"right\" class=\"heading\">" . htmlspecialchars($row["added"]) . "</td>\n");
        print("</tr>\n");
        print("<tr>\n");
        print("<td colspan=\"2\">" . $row["text"] . "</td>\n");
        print("</tr>\n");
        $count++;
    }
    print("</table>");
}

function searchfield($s) {
    # removes all non-word characters, kills leading and trailing whitespace, and replaces multiple runs of internal
    # whitespace with a single space
    return preg_replace(array('/[^a-z0-9]/si', '/^\s*/s', '/\s*$/s', '/\s+/s'), array(" ", "", "", " "), $s);
}

function genrelist() {
    $ret = array();
    $res = mysql_query("SELECT id, name, short_name FROM categories ORDER BY sort_index, id");
    while ($row = mysql_fetch_array($res))
        $ret[] = $row;
    return $ret;
}

function highest_catid() {
    $retval = 0;
    $res = mysql_query("SELECT MAX(id) from categories");
    if($res) {
        $row = mysql_fetch_row($res);
        $retval = $row[0];
    }
    return $retval;
}


function linkcolor($num) {
    if (!$num)
        return "red";
    if ($num == 1)
        return "yellow";
    return "green";
}


function hit_start() {
    return;
    global $RUNTIME_START, $RUNTIME_TIMES;
    $RUNTIME_TIMES = posix_times();
    $RUNTIME_START = gettimeofday();
}

function hit_count() {
    return;
    global $RUNTIME_CLAUSE;
    if (preg_match(',([^/]+)$,', $_SERVER["SCRIPT_NAME"], $matches))
        $path = $matches[1];
    else
        $path= "(unknown)";
    $period = date("Y-m-d H") . ":00:00";
    $RUNTIME_CLAUSE = "page = " . sqlesc($path) . " AND period = '$period'";
    $update = "UPDATE hits SET count = count + 1 WHERE $RUNTIME_CLAUSE";
    mysql_query($update);
    if (mysql_affected_rows())
        return;
    $ret = mysql_query("INSERT INTO hits (page, period, count) VALUES (" . sqlesc($path) . ", '$period', 1)");
    if (!$ret)
        mysql_query($update);
}

function hit_end() {
    return;
    global $RUNTIME_START, $RUNTIME_CLAUSE, $RUNTIME_TIMES;
    if (empty($RUNTIME_CLAUSE))
        return;
    $now = gettimeofday();
    $runtime = ($now["sec"] - $RUNTIME_START["sec"]) + ($now["usec"] - $RUNTIME_START["usec"]) / 1000000;
    $ts = posix_times();
    $sys = ($ts["stime"] - $RUNTIME_TIMES["stime"]) / 100;
    $user = ($ts["utime"] - $RUNTIME_TIMES["utime"]) / 100;
    mysql_query("UPDATE hits SET runs = runs + 1, runtime = runtime + $runtime, user_cpu = user_cpu + $user, sys_cpu = sys_cpu + $sys WHERE $RUNTIME_CLAUSE");
}

function hash_pad($hash) {
    return str_pad($hash, 20);
}

function hash_where($name, $hash) {
    $shhash = preg_replace('/ *$/s', "", $hash);
    return "($name = " . sqlesc($hash) . " OR $name = " . sqlesc($shhash) . ")";
}

function bookkeeping($torrentid) {
    # this is passed a numeric ID of a torrent from the torrents database
    # it's called to signal that there's been a state change (peer left/joined, comeplete occured, etc.)
    
    $res = mysql_query("SELECT size, seeders, leechers, times_completed, views, hits FROM torrents WHERE id = $torrentid");   
    $torrent_data = mysql_fetch_assoc($res);
    if ($torrent_data) {
                
        $torrent_size = $torrent_data["size"];
        $res = mysql_query("SELECT MIN( to_go ) / $torrent_size AS min_pct , MAX( to_go ) / $torrent_size AS max_pct , AVG( to_go ) / $torrent_size AS avg_pct FROM peers WHERE torrent = $torrentid AND seeder = 'no'");
        if($res)
            $peer_data = mysql_fetch_assoc($res);
        if(!$res || !$peer_data)
            # this means "no leechers" -- why is this not being executed?
            $peer_data = array("min_pct" => -1, "max_pct" => -1, "avg_pct" => -1);
        

        $ret = mysql_query("INSERT INTO torrents_bookkeeping (torrent_id, seeders, leechers, times_completed, views, hits, min_pct, avg_pct, max_pct, timestamp) VALUES (" .
                    implode(",", array_map("sqlesc", array($torrentid, $torrent_data["seeders"], $torrent_data["leechers"], 
                                                           $torrent_data["times_completed"], $torrent_data["views"], $torrent_data["hits"], 
                                                           $peer_data["min_pct"], $peer_data["avg_pct"], $peer_data["max_pct"]))) . ", NOW() )");
    }
}
                                                               

?>