-- MySQL dump 8.22
--
-- Host: localhost    Database: voracity_db
---------------------------------------------------------
-- Server version	3.23.57-log

--
-- Table structure for table 'avps'
--

DROP TABLE IF EXISTS avps;
CREATE TABLE avps (
  arg varchar(20) NOT NULL default '',
  value_s text NOT NULL,
  value_i int(11) NOT NULL default '0',
  value_u int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (arg)
) TYPE=MyISAM;

--
-- Table structure for table 'categories'
--

DROP TABLE IF EXISTS categories;
CREATE TABLE categories (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(30) NOT NULL default '',
  short_name varchar(30) NOT NULL default '',
  sort_index int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table 'comments'
--

DROP TABLE IF EXISTS comments;
CREATE TABLE comments (
  id int(10) unsigned NOT NULL auto_increment,
  user int(10) unsigned NOT NULL default '0',
  torrent int(10) unsigned NOT NULL default '0',
  added datetime NOT NULL default '0000-00-00 00:00:00',
  text text NOT NULL,
  ori_text text NOT NULL,
  PRIMARY KEY  (id),
  KEY user (user),
  KEY torrent (torrent)
) TYPE=MyISAM;

--
-- Table structure for table 'feature_requests'
--

DROP TABLE IF EXISTS feature_requests;
CREATE TABLE feature_requests (
  id int(10) unsigned NOT NULL auto_increment,
  submitter_id int(10) NOT NULL default '0',
  title varchar(100) NOT NULL default '',
  descr text NOT NULL,
  add_date datetime NOT NULL default '0000-00-00 00:00:00',
  yays int(10) NOT NULL default '0',
  nays int(10) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table 'files'
--

DROP TABLE IF EXISTS files;
CREATE TABLE files (
  id int(10) unsigned NOT NULL auto_increment,
  torrent int(10) unsigned NOT NULL default '0',
  filename varchar(255) NOT NULL default '',
  size bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY torrent (torrent)
) TYPE=MyISAM;

--
-- Table structure for table 'peers'
--

DROP TABLE IF EXISTS peers;
CREATE TABLE peers (
  id int(10) unsigned NOT NULL auto_increment,
  torrent int(10) unsigned NOT NULL default '0',
  peer_id char(20) binary NOT NULL default '',
  ip char(64) NOT NULL default '',
  port smallint(5) unsigned NOT NULL default '0',
  uploaded bigint(20) unsigned NOT NULL default '0',
  downloaded bigint(20) unsigned NOT NULL default '0',
  to_go bigint(20) unsigned NOT NULL default '0',
  seeder enum('yes','no') NOT NULL default 'no',
  started datetime NOT NULL default '0000-00-00 00:00:00',
  last_action datetime NOT NULL default '0000-00-00 00:00:00',
  connectable enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (id),
  UNIQUE KEY torrent_peer_id (torrent,peer_id),
  KEY torrent (torrent),
  KEY torrent_seeder (torrent,seeder),
  KEY last_action (last_action),
  KEY torrent_connectable (torrent,connectable)
) TYPE=MyISAM;

--
-- Table structure for table 'torrents'
--

DROP TABLE IF EXISTS torrents;
CREATE TABLE torrents (
  id int(10) unsigned NOT NULL auto_increment,
  info_hash varchar(20) binary NOT NULL default '',
  name varchar(255) NOT NULL default '',
  filename varchar(255) NOT NULL default '',
  save_as varchar(255) NOT NULL default '',
  search_text text NOT NULL,
  descr text NOT NULL,
  ori_descr text NOT NULL,
  category int(10) unsigned NOT NULL default '0',
  size bigint(20) unsigned NOT NULL default '0',
  added datetime NOT NULL default '0000-00-00 00:00:00',
  type enum('single','multi') NOT NULL default 'single',
  numfiles int(10) unsigned NOT NULL default '0',
  comments int(10) unsigned NOT NULL default '0',
  views int(10) unsigned NOT NULL default '0',
  hits int(10) unsigned NOT NULL default '0',
  times_completed int(10) unsigned NOT NULL default '0',
  leechers int(10) unsigned NOT NULL default '0',
  seeders int(10) unsigned NOT NULL default '0',
  last_action datetime NOT NULL default '0000-00-00 00:00:00',
  next_stats datetime NOT NULL default '0000-00-00 00:00:00',
  last_stats_datapoint datetime NOT NULL default '0000-00-00 00:00:00',
  visible enum('yes','no') NOT NULL default 'yes',
  banned enum('yes','no') NOT NULL default 'no',
  owner int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY info_hash (info_hash),
  KEY owner (owner),
  KEY visible (visible),
  KEY category_visible (category,visible),
  FULLTEXT KEY ft_search (search_text,ori_descr),
  KEY next_stats (next_stats)
) TYPE=MyISAM;

--
-- Table structure for table 'torrents_bookkeeping'
--

DROP TABLE IF EXISTS torrents_bookkeeping;
CREATE TABLE torrents_bookkeeping (
  torrent_id int(10) unsigned NOT NULL default '0',
  timestamp datetime NOT NULL default '0000-00-00 00:00:00',
  seeders int(10) unsigned NOT NULL default '0',
  leechers int(10) unsigned NOT NULL default '0',
  times_completed int(10) unsigned NOT NULL default '0',
  views int(10) unsigned NOT NULL default '0',
  hits int(10) unsigned NOT NULL default '0',
  min_pct float NOT NULL default '0',
  avg_pct float NOT NULL default '0',
  max_pct float NOT NULL default '0',
  KEY torrent_id_timestamp (torrent_id,timestamp)
) TYPE=MyISAM;

--
-- Table structure for table 'users'
--

DROP TABLE IF EXISTS users;
CREATE TABLE users (
  id int(10) unsigned NOT NULL auto_increment,
  username varchar(40) NOT NULL default '',
  password varchar(40) NOT NULL default '',
  secret varchar(20) binary NOT NULL default '',
  email varchar(80) NOT NULL default '',
  status enum('pending','confirmed') NOT NULL default 'pending',
  added datetime NOT NULL default '0000-00-00 00:00:00',
  last_login datetime NOT NULL default '0000-00-00 00:00:00',
  last_access datetime NOT NULL default '0000-00-00 00:00:00',
  admin enum('yes','no') NOT NULL default 'no',
  editsecret varchar(20) binary NOT NULL default '',
  privacy enum('strong','normal','low') NOT NULL default 'normal',
  rpp int(5) unsigned NOT NULL default '20',
  colpref_cat enum('yes','no') NOT NULL default 'yes',
  colpref_name enum('yes','no') NOT NULL default 'yes',
  colpref_comm enum('yes','no') NOT NULL default 'yes',
  colpref_added enum('yes','no') NOT NULL default 'yes',
  colpref_nfiles enum('yes','no') NOT NULL default 'no',
  colpref_size enum('yes','no') NOT NULL default 'yes',
  colpref_views enum('yes','no') NOT NULL default 'no',
  colpref_hits enum('yes','no') NOT NULL default 'yes',
  colpref_completes enum('yes','no') NOT NULL default 'yes',
  colpref_seeders enum('yes','no') NOT NULL default 'yes',
  colpref_leechers enum('yes','no') NOT NULL default 'yes',
  colpref_owner enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (id),
  UNIQUE KEY username (username),
  KEY status_added (status,added)
) TYPE=MyISAM;

